package com.engine.salary.mapper.salarysob;

import com.engine.salary.entity.salarysob.param.SalarySobCheckRuleQueryParam;
import com.engine.salary.entity.salarysob.po.SalarySobCheckRulePO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface SalarySobCheckRuleMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalarySobCheckRulePO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobCheckRulePO> listSome(SalarySobCheckRulePO salarySobCheckRule);

	List<SalarySobCheckRulePO> listByParam(SalarySobCheckRuleQueryParam param);
    

	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalarySobCheckRulePO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param salarySobCheckRule 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalarySobCheckRulePO salarySobCheckRule);
	
	/**
     * 修改，修改所有字段
     *
     * @param salarySobCheckRule 修改的记录
     * @return 返回影响行数
     */
	int update(SalarySobCheckRulePO salarySobCheckRule);
	
	/**
     * 修改，忽略null字段
     *
     * @param salarySobCheckRule 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalarySobCheckRulePO salarySobCheckRule);
	
	/**
     * 删除记录
     *
     * @param salarySobCheckRule 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalarySobCheckRulePO salarySobCheckRule);

	/**
	 * 根据主键id删除
	 *
	 * @param ids
	 */
	void deleteByIds(@Param("ids") Collection<Long> ids);

	/**
	 * 根据薪资账套id删除
	 *
	 * @param salarySobIds
	 */
	void deleteBySalarySobIds(@Param("salarySobIds") Collection<Long> salarySobIds);

	/**
	 * 批量保存
	 *
	 * @param salarySobCheckRules
	 */
	void batchInsert(@Param("collection") Collection<SalarySobCheckRulePO> salarySobCheckRules);


}